package main

import (
	//crm "loafle.com/overflow/crawler_manager_go"
	//col "loafle.com/overflow/collector_go"
	//dat "loafle.com/overflow/data_sender_go"
	//evt "loafle.com/overflow/event_sender_go"
	pol "loafle.com/overflow/long_poller_go"
	"log"
	"loafle.com/overflow/agent_api/observer/messages"
	cm "loafle.com/overflow/agent_api/config_manager"
)


func main()  {
	log.SetPrefix("Agent : ")
	StartAgent()
}

type AgentTask struct {
	command string
	params interface{}
}

type Agent struct {
	taskCh chan interface{}
	cm cm.ConfigManager
}

func StartAgent() {
	agt := Agent{}
	agt.startAgent()
}


func (agt *Agent) startAgent() {
	//cfg start() (chan confmanager, error)
	//evt start() (chan bool, error)
	//dat start() (chan bool, error)

	//pol start() (chan string, error) -> getting an Auth key from API server and store that key.
	ch, err := pol.Start(agt.cm.GetGlobalConfig())
	if err != nil {
		processError(err)
	}
	agt.taskCh = ch

	//scm start() with the Auth key (chan bool, error)
	//crm start() (chan bool, error)
	//col start() -> evt result

	go agt.waitAgentTask()
}

func (agt *Agent)waitAgentTask() {
	for {
		task := <- agt.taskCh
		switch task.(AgentTask).command {
		case messages.TASK_SENSOR_START:
			agt.processStartSensor()
			break;
		default:

		}
	}
}


func (agt *Agent) stopAgent() {
	//col stop() (chan bool, error)
	//crm stop() (chan bool, error)
	//scm stop() (chan bool, error)
	//dat stop() (chan bool, error)
	//pol stop() (chan bool, error)
	//evt stop() ->  evt result (before stop)
}

func (agt *Agent) processStartSensor() {
	//col startSensor() -> evt result
}

func (agt *Agent) processstopSensor() {
	//col stopSensor() -> evt result
}

func (agt *Agent) processAddSensor() {
	//scm addSensor() (id chan string, error)
	//crm addSensor() (id chan string, error)
	//col addSensor() -> evt result
}

func (agt *Agent) processRemoveSensor() {
	//col removeSensor() (id chan string, error)
	//crm removeSensor() (id chan string, error)
	//scm removeSensor() -> evt result
}

func (agt *Agent) processUpdateSensor() {
	//col stopSensor() (id chan string, error)
	//scm updateSensor() (id chan string, error)
	//crm updateSensor() (id chan string, error)
	//col updateSensor() -> evt result
}

func (agt *Agent) processUpdateCRM() {
	//(loop)col stopSensor() (chan []string?, error)
	//crm updateCRM()
	//(loop)col startSensor() -> evt result
}

func (agt *Agent) processUpdateAgent() {
	//
}

func (agt *Agent) processSendLog() {
	//
}

func (agt *Agent) processUpdatePolInterval() {
	//pol updateInterval()
}

func processError(err error) {
	log.Println(err)
	return
}